; File:     Files2.asm
; by:       Rui Loureiro
;           4-Nov-2010
;=====================================================
                            include     files2.glb
                            include     files2.equ

$ArquivoFic     equ FILE_ATTRIBUTE_ARCHIVE         
$ShareFic       equ FILE_SHARE_READ or FILE_SHARE_WRITE
$ModoAberRW     equ GENERIC_READ or GENERIC_WRITE
$AbreOuCria     equ OPEN_ALWAYS		           ; Se Existe Abre       se no Cria
$SubstOuCria    equ CREATE_ALWAYS		; Se Existe Substitui  se no cria
$AbreOuErro     equ OPEN_EXISTING                    ; Se Existe Abre

BUFFERLEN       equ 12000
;=====================================================
 
;  Data Section 
.data
_StaticClass    db "STATIC", 0
_ButtonClass    db "BUTTON",0                                
_EditClass      db "EDIT",0
;_IconName       db 'TDIcon', 0
;_MenuName       db 'Menu',0
_ClassName      db 'WinClass',0
_WindowName     db 'Text Files',0

_Button1        db 'Exit',0
_Button2        db 'Read Text',0
_Button3        db 'Save Text',0
_Button4        db 'Show Text',0
_Button5        db 'Clear Edit',0


_Static1        db 'Read File', 0
_Static2        db 'Text to save', 0
_Static3        db 'Write File', 0

_FileNameR      db 'Files2.asm'        ; Read file name
                db 95 dup (0)

_FileNameW      db 'Text.txt'          ; Write file name
                db 95 dup (0)
; Text 
_TextBuffer     db 'This text will be saved by WriteText    '
                db 'Read Text to see the text that was saved'
                db 'This text will be saved by WriteText    '
                db 'Read Text to see the text that was saved'
                db '                                        '                
                db 'Type the text you want to be saved      '
                db 'Put the mouse HERE and type some text   '                
                dd 0

_lTextBuffer    dd BUFFERLEN           
_rTextBuffer    db BUFFERLEN dup (0)      ; read buffer 
                dd 0
_wTextBuffer    db BUFFERLEN dup (0)      ; write buffer
                dd 0                
;  Data? Section 
.data?
;---------------------------------------
;_wcx            WNDCLASSEX <?>
_msg            MSG <?>
_x              dd ?
_y              dd ?

_icce           INITCOMMONCONTROLSEX <?>
_hInstance      dd ?
_hWnd           dd ?
_hdc            dd ?


_hEditBox1      dd ?
_hEditBox2      dd ?
_hEditBox3      dd ?
_hEditBox4      dd ?


_hButtonBox1    dd ?
_hButtonBox2    dd ?
_hButtonBox3    dd ?
_hButtonBox4    dd ?
_hButtonBox5    dd ?


_hStaticBox1    dd ?
_hStaticBox2    dd ?
_hStaticBox3    dd ?
_hStaticBox4    dd ?

;_hFile          dd ?
_BytesRW        dd ?
;  Code Section 
.code
;---------------------------------------
start:      invoke    GetModuleHandle, NULL
            mov       _hInstance, eax

            mov       _icce.dwSize, sizeof INITCOMMONCONTROLSEX
            mov       _icce.dwICC, ICC_USEREX_CLASSES

            invoke    InitCommonControlsEx, ADDR _icce    

            invoke    RegisClass, addr WndProcA, 0, 0
            
	      invoke    CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, 
                                      MAIN_STYLE1, _x, _y, $WIDTH, $HEIGHT, 
                                      0, 0, _hInstance, 0
            mov     _hWnd, eax                                     
            
            invoke    GetDC, _hWnd
            mov       _hdc, eax

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd           

;----------------------------------------------------
@@:         invoke  GetMessage, ADDR _msg, 0, 0, 0                       
            cmp     eax, 0                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           

                cmp     eax, WM_CREATE
                je      _WM_CREATE
                
                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND

; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ret
; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE::    STATICBOX1   10, 10, 160, 20, 300h
                EDITBOX1     10, 30, 160, 20, 100h
                invoke       SetWindowText, _hEditBox1, addr _FileNameR

                STATICBOX2   10, 60, 360,  20, 301h
                EDITBOX2     10, 80, 360, 120, 101h

                STATICBOX3  210, 10, 160,  20, 302h
                EDITBOX3    210, 30, 160,  20, 102h
                invoke      SetWindowText, _hEditBox3, addr _FileNameW


                BUTTONBOX1  460,  10, 60, 24, BUTTON1

                BUTTONBOX2  180, 230, 90, 24, BUTTON2
                BUTTONBOX3  300, 230, 90, 24, BUTTON3

                BUTTONBOX4  420,   90, 90, 24, BUTTON4
                BUTTONBOX5  420,  120, 90, 24, BUTTON5

                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     invoke    DestroyWindow,  hWnd
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
; 
;                     process menuitems & WM_COMMAND
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     .if     lParam==0

                    jmp      _EndProcA

                .else
                        mov     eax, edx
                        and     edx, 0FFFFh
                        shr     eax, 16
                        
                     .if     eax==BN_CLICKED

                        switch  edx
                        case    BUTTON1

                            invoke  MessageBeep, MB_ICONASTERISK
                            invoke  SendMessage, hWnd, WM_CLOSE, 0, 0                            

                        case    BUTTON2     ; Read Text

                            invoke  MessageBeep, MB_ICONEXCLAMATION
				    invoke  GetWindowText, _hEditBox1, addr _FileNameR, 100

                            call    ReadText
                            jc      short @F
                            
				    invoke  SetWindowText, _hEditBox2, addr _rTextBuffer
@@:
                        case    BUTTON3     ; Write Text

                            invoke  MessageBeep, MB_ICONHAND
				    invoke  GetWindowText, _hEditBox3, addr _FileNameW, 100
                            invoke  GetWindowText, _hEditBox2, addr _wTextBuffer, _lTextBuffer 

                            call    WriteText

                        case    BUTTON4     ; Show Text

                            invoke  MessageBeep, MB_ICONHAND
                            invoke  SetWindowText, _hEditBox2, addr _TextBuffer 

                        case    BUTTON5     ; Clear Edit

                            invoke  SetWindowText, _hEditBox2, 0

                        endsw
                        
                     .endif
                .endif
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp

;  Read to _rTextBuffer  _FileNameR 

ReadText        proc

                invoke    CreateFile, addr _FileNameR, $ModoAberRW, $ShareFic, NULL,
                                      $AbreOuErro, $ArquivoFic, NULL
                cmp       eax, INVALID_HANDLE_VALUE
                jne       short _ok
                ;
                ; Erro 
                ;
                call	    GetLastError
                cmp	    eax, ERROR_FILE_NOT_FOUND
                jne	    @F
                
                fn        MessageBox, _hWnd, "FILE_NOT_FOUND","CreateFile",MB_OK
                stc
                ret

@@:             fn        MessageBox, _hWnd, "INVALID_HANDLE_VALUE","CreateFile",MB_OK
                stc
                ret
                ;
_ok:            mov       ebx, eax
                invoke    ReadFile, ebx, addr _rTextBuffer, _lTextBuffer, addr _BytesRW, 0
                cmp       eax, 0
                jne       _close

                fn        MessageBox, _hWnd, "ERROR", "ReadFile",MB_OK
                invoke    CloseHandle, ebx
                stc
                ret
                ;
_close:         invoke    CloseHandle, ebx
                clc 
                ret
ReadText        endp

; Write from _wTextBuffer _FileNameW 

WriteText       proc

                invoke    CreateFile, addr _FileNameW, $ModoAberRW, $ShareFic, NULL,
                                      $SubstOuCria, $ArquivoFic, NULL
                cmp       eax, INVALID_HANDLE_VALUE
		    jne	  short _ok
                ;
                ; Erro 
                ;
                fn        MessageBox, _hWnd, "INVALID_HANDLE_VALUE","CreateFile",MB_OK
                ret
                
_ok:            mov       ebx, eax
                ;
                invoke    WriteFile, ebx, addr _wTextBuffer, _lTextBuffer, addr _BytesRW, 0
                cmp       eax, 0
                jne       _close

                fn        MessageBox, _hWnd, "ERROR","WriteFile",MB_OK

_close:         invoke    CloseHandle, ebx
                ret
WriteText       endp
; 
                            include     files2.inc
; ###################################################
    end     start
